#
# jpegx_encoder_stin "JPEG Extended Encoder (AXI4-ST In, AXI Out)" v1.0
# VISENGI S.L. 2017.11.28.12:23:57
# VISENGI JPEG Extended Encoder
#

#
# request TCL package from ACDS 14.0
#
package require -exact qsys 14.0


#
# module jpegx_encoder_stin
#
set_module_property DESCRIPTION "VISENGI JPEG Extended Encoder (AXI4-ST In, AXI Out)"
set_module_property NAME jpegx_encoder_stin
set_module_property VERSION 1.0
set_module_property INTERNAL false
set_module_property OPAQUE_ADDRESS_MAP true
set_module_property GROUP "DSP/Video and Image Processing"
set_module_property AUTHOR "VISENGI S.L."
set_module_property DISPLAY_NAME "VISENGI JPEG Extended Encoder (AXI4-ST In, AXI Out)"
set_module_property INSTANTIATE_IN_SYSTEM_MODULE true
set_module_property EDITABLE true
set_module_property REPORT_TO_TALKBACK false
set_module_property ALLOW_GREYBOX_GENERATION false


#
# file sets
#
add_fileset QUARTUS_SYNTH QUARTUS_SYNTH "" ""
set_fileset_property QUARTUS_SYNTH TOP_LEVEL jpegx_encoder_stin
set_fileset_property QUARTUS_SYNTH ENABLE_RELATIVE_INCLUDE_PATHS false


#
# parameters
#


#
# display items
#


#
# connection point S_AXI
#
add_interface S_AXI axi4lite end
set_interface_property S_AXI associatedClock clock_sink
set_interface_property S_AXI associatedReset reset_sink
set_interface_property S_AXI readAcceptanceCapability     1
set_interface_property S_AXI writeAcceptanceCapability    1
set_interface_property S_AXI combinedAcceptanceCapability 1
set_interface_property S_AXI readDataReorderingDepth      1
set_interface_property S_AXI bridgesToMaster ""
set_interface_property S_AXI ENABLED true
set_interface_property S_AXI EXPORT_OF ""
set_interface_property S_AXI PORT_NAME_MAP ""
set_interface_property S_AXI CMSIS_SVD_VARIABLES ""
set_interface_property S_AXI SVD_ADDRESS_GROUP ""

add_interface_port S_AXI S_AXI_AWREADY awready Output 1
add_interface_port S_AXI S_AXI_AWVALID awvalid Input  1
add_interface_port S_AXI S_AXI_AWADDR  awaddr  Input  12
add_interface_port S_AXI S_AXI_AWPROT  awprot  Input  3
add_interface_port S_AXI S_AXI_WREADY  wready  Output 1
add_interface_port S_AXI S_AXI_WVALID  wvalid  Input  1
add_interface_port S_AXI S_AXI_WDATA   wdata   Input  32
add_interface_port S_AXI S_AXI_WSTRB   wstrb   Input  4
add_interface_port S_AXI S_AXI_BREADY  bready  Input  1
add_interface_port S_AXI S_AXI_BVALID  bvalid  Output 1
add_interface_port S_AXI S_AXI_BRESP   bresp   Output 2
add_interface_port S_AXI S_AXI_ARREADY arready Output 1
add_interface_port S_AXI S_AXI_ARVALID arvalid Input  1
add_interface_port S_AXI S_AXI_ARADDR  araddr  Input  12
add_interface_port S_AXI S_AXI_ARPROT  arprot  Input  3
add_interface_port S_AXI S_AXI_RREADY  rready  Input  1
add_interface_port S_AXI S_AXI_RVALID  rvalid  Output 1
add_interface_port S_AXI S_AXI_RDATA   rdata   Output 32
add_interface_port S_AXI S_AXI_RRESP   rresp   Output 2


#
# connection point S_AXIS_PIX_IN
#
add_interface S_AXIS_PIX_IN axi4stream end
set_interface_property S_AXIS_PIX_IN associatedClock clock_sink
set_interface_property S_AXIS_PIX_IN associatedReset reset_sink
set_interface_property S_AXIS_PIX_IN ENABLED true

add_interface_port S_AXIS_PIX_IN s_axis_sink_tready     tready     Output 1
add_interface_port S_AXIS_PIX_IN s_axis_sink_tvalid     tvalid     Input  1
add_interface_port S_AXIS_PIX_IN s_axis_sink_tdata      tdata      Input  40
add_interface_port S_AXIS_PIX_IN s_axis_sink_tlast      tlast      Input  1
add_interface_port S_AXIS_PIX_IN s_axis_sink_tuser      tuser      Input  1


#
# connection point M_AXI
#
add_interface M_AXI axi start
set_interface_property M_AXI associatedClock clock_sink
set_interface_property M_AXI associatedReset reset_sink
set_interface_property M_AXI readIssuingCapability     16
set_interface_property M_AXI writeIssuingCapability    16
set_interface_property M_AXI combinedIssuingCapability 16
set_interface_property M_AXI ENABLED true
set_interface_property M_AXI EXPORT_OF ""
set_interface_property M_AXI PORT_NAME_MAP ""
set_interface_property M_AXI CMSIS_SVD_VARIABLES ""
set_interface_property M_AXI SVD_ADDRESS_GROUP ""

add_interface_port M_AXI m_axi_awready awready Input  1
add_interface_port M_AXI m_axi_awvalid awvalid Output 1
add_interface_port M_AXI m_axi_awaddr  awaddr  Output 32
add_interface_port M_AXI m_axi_awlen   awlen   Output 4
add_interface_port M_AXI m_axi_awsize  awsize  Output 3
add_interface_port M_AXI m_axi_awburst awburst Output 2
add_interface_port M_AXI m_axi_awcache awcache Output 4
add_interface_port M_AXI m_axi_awprot  awprot  Output 3
add_interface_port M_AXI m_axi_wready  wready  Input  1
add_interface_port M_AXI m_axi_wvalid  wvalid  Output 1
add_interface_port M_AXI m_axi_wdata   wdata   Output 32
add_interface_port M_AXI m_axi_wstrb   wstrb   Output 4
add_interface_port M_AXI m_axi_wlast   wlast   Output 1
add_interface_port M_AXI m_axi_bready  bready  Output 1
add_interface_port M_AXI m_axi_bvalid  bvalid  Input  1
add_interface_port M_AXI m_axi_bresp   bresp   Input  2
add_interface_port M_AXI m_axi_arready arready Input  1
add_interface_port M_AXI m_axi_arvalid arvalid Output 1
add_interface_port M_AXI m_axi_araddr  araddr  Output 32
add_interface_port M_AXI m_axi_arlen   arlen   Output 4
add_interface_port M_AXI m_axi_arsize  arsize  Output 3
add_interface_port M_AXI m_axi_arburst arburst Output 2
add_interface_port M_AXI m_axi_arcache arcache Output 4
add_interface_port M_AXI m_axi_arprot  arprot  Output 3
add_interface_port M_AXI m_axi_rready  rready  Output 1
add_interface_port M_AXI m_axi_rvalid  rvalid  Input  1
add_interface_port M_AXI m_axi_rdata   rdata   Input  32
add_interface_port M_AXI m_axi_rresp   rresp   Input  2
add_interface_port M_AXI m_axi_rlast   rlast   Input  1

add_interface_port M_AXI m_axi_awid    awid    Output 4
add_interface_port M_AXI m_axi_wid     wid     Output 4
add_interface_port M_AXI m_axi_bid     bid     Input  4
add_interface_port M_AXI m_axi_arid    arid    Output 4
add_interface_port M_AXI m_axi_rid     rid     Input  4

add_interface_port M_AXI m_axi_awlock  awlock  Output 2
add_interface_port M_AXI m_axi_arlock  arlock  Output 2


#
# connection point clock_sink
#
add_interface clock_sink clock end
set_interface_property clock_sink clockRate 0
set_interface_property clock_sink ENABLED true
set_interface_property clock_sink EXPORT_OF ""
set_interface_property clock_sink PORT_NAME_MAP ""
set_interface_property clock_sink CMSIS_SVD_VARIABLES ""
set_interface_property clock_sink SVD_ADDRESS_GROUP ""

add_interface_port clock_sink clk clk Input 1


#
# connection point reset_sink
#
add_interface reset_sink reset end
set_interface_property reset_sink associatedClock clock_sink
set_interface_property reset_sink synchronousEdges DEASSERT
set_interface_property reset_sink ENABLED true
set_interface_property reset_sink EXPORT_OF ""
set_interface_property reset_sink PORT_NAME_MAP ""
set_interface_property reset_sink CMSIS_SVD_VARIABLES ""
set_interface_property reset_sink SVD_ADDRESS_GROUP ""

add_interface_port reset_sink rst reset_n Input 1


#
# connection point JPEGEX_int_o
#
add_interface JPEGEX_int_o interrupt end
set_interface_property JPEGEX_int_o associatedAddressablePoint ""
set_interface_property JPEGEX_int_o associatedClock clock_sink
set_interface_property JPEGEX_int_o associatedReset reset_sink
set_interface_property JPEGEX_int_o bridgedReceiverOffset ""
set_interface_property JPEGEX_int_o bridgesToReceiver ""
set_interface_property JPEGEX_int_o ENABLED true
set_interface_property JPEGEX_int_o EXPORT_OF ""
set_interface_property JPEGEX_int_o PORT_NAME_MAP ""
set_interface_property JPEGEX_int_o CMSIS_SVD_VARIABLES ""
set_interface_property JPEGEX_int_o SVD_ADDRESS_GROUP ""

add_interface_port JPEGEX_int_o JPEGEX_int_o irq Output 1
set_interface_assignment JPEGEX_int_o embeddedsw.dts.irq.tx_type RISING_EDGE


set_module_assignment embeddedsw.dts.vendor visengi
set_module_assignment embeddedsw.dts.group  jpegex
set_module_assignment embeddedsw.dts.name   jpegex
# set_module_assignment embeddedsw.dts.compatible {visengi,jpegex-1.00}
